## priv-wrapper 1.0.1

=== CMakeLists.txt ===
# Required cmake version
cmake_minimum_required(VERSION 3.5.0)
cmake_policy(SET CMP0048 NEW)

# Specify search path for CMake modules to be loaded by include()
# and find_package()
list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake/Modules")

# Add defaults for cmake
# Those need to be set before the project() call.
include(DefineCMakeDefaults)
include(DefineCompilerFlags)

project(priv_wrapper VERSION 1.0.1 LANGUAGES C)

# global needed variables
set(APPLICATION_NAME ${PROJECT_NAME})

# SOVERSION scheme: MAJOR.MINOR.PATCH
#   If there was an incompatible interface change:
#     Increment MAJOR. Set MINOR and PATCH to 0
#   If there was a compatible interface change:
#     Increment MINOR. Set PATCH to 0
#   If the source code was changed, but there were no interface changes:
#     Increment PATCH.
set(LIBRARY_VERSION_MAJOR 0)
set(LIBRARY_VERSION_MINOR 0)
set(LIBRARY_VERSION_PATCH 2)
set(LIBRARY_VERSION "${LIBRARY_VERSION_MAJOR}.${LIBRARY_VERSION_MINOR}.${LIBRARY_VERSION_PATCH}")
set(LIBRARY_SOVERSION ${LIBRARY_VERSION_MAJOR})

# add definitions
include(DefinePlatformDefaults)
include(DefineOptions.cmake)
include(CPackConfig.cmake)
include(CompilerChecks.cmake)
include(GNUInstallDirs)

# disallow in-source build
include(MacroEnsureOutOfSourceBuild)
macro_ensure_out_of_source_build("${PROJECT_NAME} requires an out of source build. Please create a separate build directory and run 'cmake /path/to/${PROJECT_NAME} [options]' there.")

# Find out if we have threading available
set(CMAKE_THREAD_PREFER_PTHREADS ON)
find_package(Threads)

# config.h checks
include(ConfigureChecks.cmake)
configure_file(config.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config.h)

# check subdirectories
add_subdirectory(src)

if (UNIT_TESTING)
    find_package(cmocka 1.1.0 REQUIRED)

    include(AddCMockaTest)
    add_subdirectory(tests)
endif (UNIT_TESTING)

# pkg-config file
get_filename_component(PRIV_WRAPPER_LIB ${PRIV_WRAPPER_LOCATION} NAME)

configure_file(priv_wrapper.pc.cmake ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper.pc @ONLY)
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper.pc
  DESTINATION
      ${CMAKE_INSTALL_LIBDIR}/pkgconfig
  COMPONENT
    pkgconfig
)

# cmake config files
configure_file(priv_wrapper-config-version.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper-config-version.cmake @ONLY)
configure_file(priv_wrapper-config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper-config.cmake @ONLY)
install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper-config-version.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/priv_wrapper-config.cmake
    DESTINATION
        ${CMAKE_INSTALL_LIBDIR}/cmake/priv_wrapper
    COMPONENT
        devel
)

add_subdirectory(doc)

=== doc/CMakeLists.txt ===
install(FILES
            priv_wrapper.1
        DESTINATION
            ${CMAKE_INSTALL_MANDIR}/man1)

=== src/CMakeLists.txt ===
project(libpriv_wrapper C)

add_library(priv_wrapper SHARED priv_wrapper.c)
target_include_directories(priv_wrapper
                           PRIVATE
                               ${CMAKE_BINARY_DIR})
target_compile_options(priv_wrapper
                       PRIVATE
                          -D_GNU_SOURCE)
target_link_libraries(priv_wrapper
                      PRIVATE defaults ${PWRAP_REQUIRED_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})

set_target_properties(priv_wrapper
                      PROPERTIES
                          VERSION ${LIBRARY_VERSION}
                          SOVERSION ${LIBRARY_SOVERSION})

install(TARGETS priv_wrapper
        RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
        LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
        ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

set(PRIV_WRAPPER_LOCATION "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_SHARED_LIBRARY_PREFIX}priv_wrapper${CMAKE_SHARED_LIBRARY_SUFFIX}" PARENT_SCOPE)

=== tests/CMakeLists.txt ===
project(tests C)

include_directories(
  ${CMAKE_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/src
  ${CMOCKA_INCLUDE_DIR}
)

set(PWRAP_TESTS
    test_setrlimit
    test_chroot)

if (HAVE_PRCTL)
list(APPEND PWRAP_TESTS test_prctl)
endif()

if (HAVE_PLEDGE)
list(APPEND PWRAP_TESTS test_pledge)
endif()

function(ADD_CMOCKA_TEST_ENVIRONMENT _TEST_NAME)
    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer")
            find_library(ASAN_LIBRARY
                         NAMES asan)
            if (NOT ASAN_LIBRARY)
                foreach(version RANGE 10 1)
                    if (NOT ASAN_LIBRARY)
                        find_library(ASAN_LIBRARY libasan.so.${version})
                    endif()
                endforeach()
            endif()
        endif()
    endif()

    if (ASAN_LIBRARY)
        list(APPEND PRELOAD_LIBRARIES ${ASAN_LIBRARY})
    endif()
    list(APPEND PRELOAD_LIBRARIES ${PRIV_WRAPPER_LOCATION})

    if (OSX)
        set(TORTURE_ENVIRONMENT "DYLD_FORCE_FLAT_NAMESPACE=1;DYLD_INSERT_LIBRARIES=${PRIV_WRAPPER_LOCATION}")
    else ()
        string(REPLACE ";" ":" _TMP_ENV "${PRELOAD_LIBRARIES}")
        set(TORTURE_ENVIRONMENT "LD_PRELOAD=${_TMP_ENV}")
    endif()

    if (CMAKE_BUILD_TYPE)
        string(TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_LOWER)
        if (CMAKE_BUILD_TYPE_LOWER STREQUAL "addresssanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "threadsanitizer" OR
            CMAKE_BUILD_TYPE_LOWER STREQUAL "undefinedsanitizer")
            list(APPEND TORTURE_ENVIRONMENT "PRIV_WRAPPER_DISABLE_DEEPBIND=1")
        endif()
    endif()

    set_property(TEST
                    ${_TEST_NAME}
                PROPERTY
                    ENVIRONMENT "${TORTURE_ENVIRONMENT}")
endfunction()

foreach(_PWRAP_TEST ${PWRAP_TESTS})
    add_cmocka_test(${_PWRAP_TEST}
                    SOURCES ${_PWRAP_TEST}.c
                    COMPILE_OPTIONS -D_GNU_SOURCE
                    LINK_LIBRARIES ${CMOCKA_LIBRARY} PRIVATE defaults)
    add_cmocka_test_environment(${_PWRAP_TEST})
endforeach()

=== debian/changelog ===
priv-wrapper (1.0.1-6) unstable; urgency=medium

  * Re-tag using quilt=gbp

 -- Simon Josefsson <simon@josefsson.org>  Tue, 17 Feb 2026 22:33:01 +0100

priv-wrapper (1.0.1-5) unstable; urgency=medium

  * Drop Priority: optional
  * Standards-Version: 4.7.3
  * Drop Rules-Requires-Root: no
  * Bump debian/* copyright years
  * Use watch v5
  * Run wrap-and-sort -satbk
  * Move manpage to source file in /usr/share/doc/priv-wrapper/

 -- Simon Josefsson <simon@josefsson.org>  Tue, 17 Feb 2026 18:30:02 +0100

priv-wrapper (1.0.1-4) unstable; urgency=medium

  [ Helge Deller ]
  * Fix prctrl test on Alpha/sparc64.  Closes: #1069486.
  * Disable time64 transition.  Closes: #1069486.

  [ Simon Josefsson ]
  * tests: Make building verbose, print CC commands.
  * Replace tests/wrap-and-sort with pipeline job.
  * Run wrap-and-sort -satbk.
  * Fix typo in manpage.
  * Standards-Version: 4.7.0.
  * Fix lintian update-debian-copyright.
  * Use execute_after_* instead of override_* in rules.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 06 Nov 2024 09:49:30 +0100

priv-wrapper (1.0.1-3) unstable; urgency=medium

  * Fix --twice builds.  Closes: #1046970.
  * tests: Add manpage-rebuild.
  * tests: Add wrap-and-sort.

 -- Simon Josefsson <simon@josefsson.org>  Wed, 16 Aug 2023 11:10:16 +0200

priv-wrapper (1.0.1-2) unstable; urgency=medium

  * Team maintain package.
  * wrap-and-sort -satb.
  * tests: Output errors on failure.
  * Rebuild manpage using asciidoctor.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 08 Aug 2023 23:29:10 +0200

priv-wrapper (1.0.1-1) unstable; urgency=low

  * Initial packaging.  Closes: #1042827.

 -- Simon Josefsson <simon@josefsson.org>  Tue, 01 Aug 2023 16:29:44 +0200

=== debian/control ===
Source: priv-wrapper
Maintainer: Debian SSSD Team <pkg-sssd-devel@alioth-lists.debian.net>
Uploaders:
 Timo Aaltonen <tjaalton@debian.org>,
 Simon Josefsson <simon@josefsson.org>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libcmocka-dev,
Standards-Version: 4.7.3
Section: devel
Homepage: https://cwrap.org/priv_wrapper.html
Vcs-Browser: https://salsa.debian.org/sssd-team/priv-wrapper
Vcs-Git: https://salsa.debian.org/sssd-team/priv-wrapper.git

Package: libpriv-wrapper
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Privilege wrapper library
 priv_wrapper is a library to disable resource limits and other
 privilege dropping.
 .
 priv_wrapper allows one to disable chroot, prctl, pledge and setrlmit
 system calls.
 .
 priv_wrapper aims to help running processes which are dropping
 privileges or are restricting resources in test environments.
 .
 Like other cwrap projects, it works as a LD preload library, which
 overrides various system functions.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=-time64

%:
	dh $@ --builddirectory=build

unittest = $(if $(filter nocheck,$(DEB_BUILD_OPTIONS)),,-DUNIT_TESTING=1)

execute_after_dh_auto_install: # lintian spare-manual-page
	rm -rfv debian/libpriv-wrapper/usr/share/man

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_VERBOSE_MAKEFILE=ON \
		$(unittest)

=== debian/tests/control ===
Tests:
 tests,
Depends:
 cmake,
 gcc,
 libc-dev,
 libcmocka-dev,
 libpriv-wrapper,
 make,
Restrictions:
 allow-stderr,

=== debian/watch ===
Version: 5
Source: https://ftp.samba.org/pub/cwrap/
Matching-Pattern: priv_wrapper-@ANY_VERSION@@ARCHIVE_EXT@
Pgpsigurlmangle: s/$/.asc/
